Subject: Re: linux-next: build warning after merge of the wireless tree

From: Stephen Rothwell <[email-masked]>
Date: Wed, 28 Apr 2010 16:17:57 +1000

Hi John,

On Tue, 27 Apr 2010 10:07:12 -0700 Steve deRosier <[email-masked]> wrote:
>
> On Tue, Apr 27, 2010 at 8:40 AM, John W. Linville
> <[email-masked]> wrote:
> >
> > Right.  So in wireless-testing I did the includes in the other order
> > (i.e. "deb_defs.h" first), but that is a bit ugly.  Any suggestions
> > on alternatives?

I have done that as well for today in linux-next.

> > "#undef pr_fmt" just before the "#define pr_fmt(fmt)..." line in
> > db_defs.h seems to eliminate the warning even with the more normal
> > ordering of the #include lines.  I'm not familiar with the usage of
> > pr_fmt -- will doing the above preserve the desired effect?
>
> I thought about that particular strategy (doing the #undef) instead of
> the non-traditional include mess.  But not being familiar enough with
> the pr_fmt stuff, I didn't want to do it.
> 
> My goal was to get the '#define pr_fmt(fmt) KBUILD_MODNAME ": " fmt'
> line in the deb_defs.h header so it was only in one place.  But to
> build, that define must be before kernel.h gets included anywhere.
> Hence the current mess.
> 
> I'm OK with the #undef strategy and moving the deb_defs.h include to a
> better position if that's the correct way to do this.  Please let me
> know if I have any action items on this.

The only problem I could see with that is is there are some inline
functions in the headers files between where the first and second #define
pr_fmt s get done.

-- 
Cheers,
Stephen Rothwell                    [email-masked]
http://www.canb.auug.org.au/~sfr/